// PingDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PingDemo.h"
#include "PingDemoDlg.h"
#include "CPing.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPingDemoDlg dialog

CPingDemoDlg::CPingDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPingDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPingDemoDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPingDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPingDemoDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPingDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CPingDemoDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_PING, OnPing)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPingDemoDlg message handlers

BOOL CPingDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPingDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPingDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CPingDemoDlg::OnPing() 
{
	CString strHost;
	
	//get the text out of the host textbox
	GetDlgItemText(IDC_HOST, strHost);

	//ping the host
	BOOL bResult = ping.Ping((char*)(LPCTSTR)strHost);
	
	//show the user the results
	if(bResult)
	{
		//up and running
		AfxMessageBox("Host is up and running.");
	}
	else
	{
		//host is down or name is invalid
		AfxMessageBox("Host name is invalid or the host is not responding.");
	}
}
